
def add_object(config, folder):

    from ZPublisher.mapply import mapply
    
    product = config.product.strip()
    factory = config.factory.strip()

    product_dispatcher = folder.manage_addProduct[product]
    factory_dispatcher = getattr(product_dispatcher, factory)

    mapply(factory_dispatcher,
           keyword=config,
           context=config,
           bind=1
           )

def add_property(config, obj):
    from Acquisition import aq_base

    id = config.id
    type = config.type
    value = config.value.strip()
    
    if hasattr(aq_base(obj), 'manage_addProperty'):
        obj.manage_addProperty(id, value, type)

def invoke_external_method(config, object):
    # we don't handle positional args only kw args

    module = config.extensionmodule.strip()
    func   = config.extensionfunction.strip()

    from App.Extensions import getObject
    from ZPublisher.mapply import mapply
 
    em = getObject(module, func)
  
    res = mapply(em,
	    positional=(object,),
            keyword=config,
	    context=config,
	    bind=0
            )

    return res

    
