from lib import logging
import inspect
from os import path

def getLog(object):
    log_path = ['TaskEngine']
    try:
        filepath = inspect.getsourcefile(object)
    except Exception, e:
        filepath = inspect.getsourcefile(object.__class__)
        
    module   = path.splitext(path.basename(filepath))[0]
    log_path.append(module)

    try:
        log_path.append(object.getId())
    except:
        pass

    return logging.getLogger('.'.join(log_path))

def setLogLevel(option, opt, value, parser):
    """
    optik callback to set log level
    """
    if value and value not in logging._levelNames.keys():
        parser.error("Invalid Value For Log Level")
        
    logging.disable(value)

    return value

    
"""
XXX
This is extremely cheesy!!!
"""

from cStringIO import StringIO

_log_ini = """
[loggers]
keys=root,log02,log03,log04,log05,log07,log09,log10,log12

[handlers]
keys=hand01,hand02

[formatters]
keys=form01

[logger_root]
level=ALL
propagate=1
channel=
parent=
qualname=(root)
handlers=

[logger_log02]
level=INFO
propagate=0
channel=TaskEngine
parent=(root)
qualname=TaskEngine
handlers=hand01,hand02

[logger_log03]
level=ALL
propagate=1
channel=Engine
parent=log02
qualname=TaskEngine.Engine
handlers=

[logger_log04]
level=ALL
propagate=1
channel=Pools
parent=log02
qualname=TaskEngine.Pools
handlers=

[logger_log05]
level=ALL
propagate=1
channel=TaskRunner
parent=log02
qualname=TaskEngine.TaskRunner
handlers=

[logger_log07]
level=ALL
propagate=1
channel=Environment
parent=log02
qualname=TaskEngine.Environment
handlers=

[logger_log09]
level=ALL
propagate=1
channel=Loader
parent=log02
qualname=TaskEngine.Loader
handlers=

[logger_log10]
level=ALL
propagate=1
channel=Reader
parent=log02
qualname=TaskEngine.Reader
handlers=

[logger_log12]
level=ALL
propagate=1
channel=Task
parent=log02
qualname=TaskEngine.Task
handlers=

[handler_hand01]
class=StreamHandler
level=ALL
formatter=form01
stream=sys.stderr
args=(sys.stderr,)

[handler_hand02]
class=FileHandler
level=ALL
formatter=form01
filename=engine.log
mode=a+
maxsize=0
backcount=1
args=('engine.log', 'a+')

[formatter_form01]
format=%(name)s %(levelname)s %(message)s
datefmt=
"""

log_ini = StringIO(_log_ini)
