class SetException(Exception): pass

# edges are ignored, order is everything.

class Set:

    def __init__(self, set=()):
        
        self.data = {}
        self.order = []

        for i in set:
            self.addNode(i)

    def addNode(self, node):

        node_id = node.getId()
        if self.data.has_key(node_id):
            raise SetException("%s already in set"%str(node))
        
        self.data[node_id]=node
        self.order.append(node_id)

    def getNode(self, node_id):

        return self.data[node_id]

    def getNodeIds(self):
        
        return tuple(self.order)

    def __len__(self):
        return len(self.data)
